using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.DirectoryServices;
using System.IO;

using Conaito;

namespace ConaitoFTPSample
{
	enum LocalEntryType
	{
		Dir,
		File
	}

	struct LocalEntry
	{
		public LocalEntryType Type;
		public String Path;
	}

	public class Form1 : System.Windows.Forms.Form
	{
		ArrayList LocalEntries = new ArrayList();
		String CurrPath = "";

        private ArrayList stack = new ArrayList();
		private FtpClient conn = new FtpClient();
		private System.Windows.Forms.TextBox textHostname;
		private System.Windows.Forms.Label labelHostname;
		private System.Windows.Forms.Label labelUser;
		private System.Windows.Forms.TextBox textUser;
		private System.Windows.Forms.Label labelPassword;
		private System.Windows.Forms.TextBox textPassword;
		private System.Windows.Forms.Button buttonConnect;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ColumnHeader columnName;
		private System.Windows.Forms.ColumnHeader columnType;
		private System.Windows.Forms.ColumnHeader columnSize;
		private System.Windows.Forms.ColumnHeader columnDate;
		private System.Windows.Forms.ListView listBoxDirectories;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.ComboBox cbDrives;
		private System.Windows.Forms.Label lblLocalDir;
		private System.Windows.Forms.ListView lwLocalDir;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.ListBox listBoxLog;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Label label8;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		#region Constructors/destructors
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
        
			InitConnection();

			InitDrivesCombo();
			FillLocalDir(cbDrives.SelectedItem.ToString());
		}
        
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
        
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textHostname = new System.Windows.Forms.TextBox();
			this.labelHostname = new System.Windows.Forms.Label();
			this.labelUser = new System.Windows.Forms.Label();
			this.textUser = new System.Windows.Forms.TextBox();
			this.labelPassword = new System.Windows.Forms.Label();
			this.textPassword = new System.Windows.Forms.TextBox();
			this.buttonConnect = new System.Windows.Forms.Button();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.panel1 = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.columnName = new System.Windows.Forms.ColumnHeader();
			this.columnType = new System.Windows.Forms.ColumnHeader();
			this.columnSize = new System.Windows.Forms.ColumnHeader();
			this.columnDate = new System.Windows.Forms.ColumnHeader();
			this.listBoxDirectories = new System.Windows.Forms.ListView();
			this.label2 = new System.Windows.Forms.Label();
			this.lblLocalDir = new System.Windows.Forms.Label();
			this.lwLocalDir = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.cbDrives = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.listBoxLog = new System.Windows.Forms.ListBox();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.label8 = new System.Windows.Forms.Label();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// textHostname
			// 
			this.textHostname.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textHostname.Location = new System.Drawing.Point(80, 56);
			this.textHostname.Name = "textHostname";
			this.textHostname.Size = new System.Drawing.Size(176, 20);
			this.textHostname.TabIndex = 0;
			this.textHostname.TabStop = false;
			this.textHostname.Text = "ftp.uar.net";
			// 
			// labelHostname
			// 
			this.labelHostname.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.labelHostname.Location = new System.Drawing.Point(8, 56);
			this.labelHostname.Name = "labelHostname";
			this.labelHostname.Size = new System.Drawing.Size(64, 23);
			this.labelHostname.TabIndex = 1;
			this.labelHostname.Text = "Hostname:";
			// 
			// labelUser
			// 
			this.labelUser.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.labelUser.Location = new System.Drawing.Point(8, 80);
			this.labelUser.Name = "labelUser";
			this.labelUser.Size = new System.Drawing.Size(64, 23);
			this.labelUser.TabIndex = 3;
			this.labelUser.Text = "User:";
			// 
			// textUser
			// 
			this.textUser.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textUser.Location = new System.Drawing.Point(80, 80);
			this.textUser.Name = "textUser";
			this.textUser.Size = new System.Drawing.Size(176, 20);
			this.textUser.TabIndex = 2;
			this.textUser.TabStop = false;
			this.textUser.Text = "anonymous";
			// 
			// labelPassword
			// 
			this.labelPassword.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.labelPassword.Location = new System.Drawing.Point(8, 104);
			this.labelPassword.Name = "labelPassword";
			this.labelPassword.Size = new System.Drawing.Size(64, 23);
			this.labelPassword.TabIndex = 5;
			this.labelPassword.Text = "Password:";
			// 
			// textPassword
			// 
			this.textPassword.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.textPassword.Location = new System.Drawing.Point(80, 104);
			this.textPassword.Name = "textPassword";
			this.textPassword.Size = new System.Drawing.Size(176, 20);
			this.textPassword.TabIndex = 4;
			this.textPassword.TabStop = false;
			this.textPassword.Text = "";
			// 
			// buttonConnect
			// 
			this.buttonConnect.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.buttonConnect.Location = new System.Drawing.Point(8, 128);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(72, 23);
			this.buttonConnect.TabIndex = 9;
			this.buttonConnect.TabStop = false;
			this.buttonConnect.Text = "Connect";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.label1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(864, 50);
			this.panel1.TabIndex = 14;
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.DodgerBlue;
			this.label1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.label1.Font = new System.Drawing.Font("Arial", 24F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label1.ForeColor = System.Drawing.Color.White;
			this.label1.Location = new System.Drawing.Point(0, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(864, 50);
			this.label1.TabIndex = 0;
			this.label1.Text = "Conaito FTP SDK Sample Client";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// columnName
			// 
			this.columnName.Text = "Name";
			this.columnName.Width = 130;
			// 
			// columnType
			// 
			this.columnType.Text = "Type";
			// 
			// columnSize
			// 
			this.columnSize.Text = "Size";
			// 
			// columnDate
			// 
			this.columnDate.Text = "Date";
			this.columnDate.Width = 102;
			// 
			// listBoxDirectories
			// 
			this.listBoxDirectories.AutoArrange = false;
			this.listBoxDirectories.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.listBoxDirectories.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																								 this.columnName,
																								 this.columnType,
																								 this.columnSize,
																								 this.columnDate});
			this.listBoxDirectories.FullRowSelect = true;
			this.listBoxDirectories.GridLines = true;
			this.listBoxDirectories.Location = new System.Drawing.Point(8, 176);
			this.listBoxDirectories.MultiSelect = false;
			this.listBoxDirectories.Name = "listBoxDirectories";
			this.listBoxDirectories.Size = new System.Drawing.Size(400, 400);
			this.listBoxDirectories.TabIndex = 13;
			this.listBoxDirectories.View = System.Windows.Forms.View.Details;
			this.listBoxDirectories.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listBoxDirectories_KeyDown);
			// 
			// label2
			// 
			this.label2.BackColor = System.Drawing.Color.DodgerBlue;
			this.label2.ForeColor = System.Drawing.Color.White;
			this.label2.Location = new System.Drawing.Point(8, 160);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(400, 16);
			this.label2.TabIndex = 15;
			// 
			// lblLocalDir
			// 
			this.lblLocalDir.BackColor = System.Drawing.Color.DodgerBlue;
			this.lblLocalDir.ForeColor = System.Drawing.Color.White;
			this.lblLocalDir.Location = new System.Drawing.Point(456, 184);
			this.lblLocalDir.Name = "lblLocalDir";
			this.lblLocalDir.Size = new System.Drawing.Size(400, 16);
			this.lblLocalDir.TabIndex = 17;
			// 
			// lwLocalDir
			// 
			this.lwLocalDir.AutoArrange = false;
			this.lwLocalDir.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lwLocalDir.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.columnHeader1,
																						 this.columnHeader2,
																						 this.columnHeader3,
																						 this.columnHeader4});
			this.lwLocalDir.FullRowSelect = true;
			this.lwLocalDir.GridLines = true;
			this.lwLocalDir.Location = new System.Drawing.Point(456, 200);
			this.lwLocalDir.MultiSelect = false;
			this.lwLocalDir.Name = "lwLocalDir";
			this.lwLocalDir.Size = new System.Drawing.Size(400, 376);
			this.lwLocalDir.TabIndex = 16;
			this.lwLocalDir.View = System.Windows.Forms.View.Details;
			this.lwLocalDir.KeyDown += new System.Windows.Forms.KeyEventHandler(this.lwLocalDir_KeyDown);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Name";
			this.columnHeader1.Width = 130;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Type";
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "Size";
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "Date";
			this.columnHeader4.Width = 102;
			// 
			// cbDrives
			// 
			this.cbDrives.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbDrives.Location = new System.Drawing.Point(456, 160);
			this.cbDrives.Name = "cbDrives";
			this.cbDrives.Size = new System.Drawing.Size(96, 21);
			this.cbDrives.TabIndex = 18;
			this.cbDrives.TabStop = false;
			this.cbDrives.SelectedIndexChanged += new System.EventHandler(this.cbDrives_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(272, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 16);
			this.label3.TabIndex = 19;
			this.label3.Text = "Help:";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(272, 72);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(184, 16);
			this.label4.TabIndex = 20;
			this.label4.Text = "Use Up/Down/Enter to browse files";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(272, 88);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(100, 16);
			this.label5.TabIndex = 21;
			this.label5.Text = "Use F5 to copy file";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(272, 104);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(136, 16);
			this.label6.TabIndex = 22;
			this.label6.Text = "Use F7 to make directory";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(272, 120);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(176, 16);
			this.label7.TabIndex = 23;
			this.label7.Text = "Use Del to delete file or directory";
			// 
			// listBoxLog
			// 
			this.listBoxLog.Location = new System.Drawing.Point(8, 584);
			this.listBoxLog.Name = "listBoxLog";
			this.listBoxLog.Size = new System.Drawing.Size(848, 108);
			this.listBoxLog.TabIndex = 24;
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Location = new System.Drawing.Point(88, 128);
			this.button1.Name = "button1";
			this.button1.TabIndex = 25;
			this.button1.Text = "Disconnect";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(480, 56);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(88, 23);
			this.button2.TabIndex = 26;
			this.button2.Text = "Check License";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(480, 88);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(144, 16);
			this.label8.TabIndex = 27;
			this.label8.Text = "License is not checked";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(864, 702);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.listBoxLog);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.cbDrives);
			this.Controls.Add(this.lblLocalDir);
			this.Controls.Add(this.lwLocalDir);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.listBoxDirectories);
			this.Controls.Add(this.buttonConnect);
			this.Controls.Add(this.labelPassword);
			this.Controls.Add(this.textPassword);
			this.Controls.Add(this.textUser);
			this.Controls.Add(this.textHostname);
			this.Controls.Add(this.labelUser);
			this.Controls.Add(this.labelHostname);
			this.Name = "Form1";
			this.Text = "Conaito FTP 1.0 Sample";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion    
		#endregion        

		#region Main
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]								  
		static void Main() 
		{
			Application.Run(new Form1());
		}
            
		#endregion        
		
		#region Utility methods
		private void InitConnection()
		{
			conn.UseLog = true;			
		}
		private void GetFile(String remoteName)
		{
			if (saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				conn.IsASCIIFileTransferType = false;
				conn.DownloadFile(remoteName, saveFileDialog1.FileName);
				Log();
			}
		}
		private void ChangeDir()
		{
			if (listBoxDirectories.SelectedItems == null || listBoxDirectories.SelectedItems.Count == 0)
				return;
			String sel = listBoxDirectories.SelectedItems[0].Text;
			if (sel == "")
				return;
			if (sel.Substring(0, 2) != "[ " && sel != "..")
			{
				GetFile(listBoxDirectories.SelectedItems[0].Text + "." + listBoxDirectories.SelectedItems[0].SubItems[1].Text);
				return;
			}
			if (sel.Substring(0, 2) == "[ ")
				sel = sel.Substring(2, sel.Length - 4);
			if (sel == "..")
			{
				if (stack.Count == 0)
					return;
				stack.RemoveAt(stack.Count-1);
				conn.UpDir();
			}
			else
			{
				stack.Add(sel);
				conn.ChangeDir(sel);
				Log();
			}

			FillCurr();
		}
		private void FillCurr()
		{
			listBoxDirectories.Items.Clear();
			listBoxDirectories.Items.Add("..");
			ArrayList directories = conn.ListDirEx();
			Log();
			for( int i = 0; i < directories.Count; ++i )
			{
				String[] info = (String[])directories[i];
				if (info.Length > 2)
				{			
					String attrs = info[0];	
					String name = "";
					String type = "";
					if (attrs.Substring(0, 2) == "dr")
						name = "[ " + info[info.Length - 1] + " ]";
					else
					{
						int n = info[info.Length - 1].LastIndexOf(".");
						if (n < 0)
						{
							name = info[info.Length - 1];
							type = "";
						}
						else
						{
							name = info[info.Length - 1].Substring(0, n);
							type = info[info.Length - 1].Substring(n+1);
						}
					}
					ListViewItem it = new ListViewItem(name);
					it.SubItems.Add(type);
					it.SubItems.Add(attrs);
					listBoxDirectories.Items.Add(it);
				}
			}
			listBoxDirectories.Focus();
			listBoxDirectories.Select();
		}
		private void listBoxDirectories_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			switch (e.KeyCode)
			{
				case Keys.Enter:
					ChangeDir();
					break;
				case Keys.F5:
					if (listBoxDirectories.SelectedItems[0].Text.Substring(0, 2) != "[ ")
					{
						conn.DownloadFile(listBoxDirectories.SelectedItems[0].Text + "." + listBoxDirectories.SelectedItems[0].SubItems[1].Text, CurrPath +
							"\\" + listBoxDirectories.SelectedItems[0].Text + "." + listBoxDirectories.SelectedItems[0].SubItems[1].Text);
						Log();
					}
					break;
				case Keys.F7:
					FormCrDir fcd = new FormCrDir();
					DialogResult dr =  fcd.ShowDialog();
					if (dr == DialogResult.OK)
					{
						try
						{
							conn.MakeDir(fcd.DirName);
						}
						catch(Exception ex)
						{
							Log(ex.Message);
						}
						Log();
					}
					FillCurr();
					break;
				case Keys.Delete:
					if (listBoxDirectories.SelectedItems[0].Text.Substring(0, 2) != "[ ")
					{
						try
						{
							conn.DeleteFile(listBoxDirectories.SelectedItems[0].Text + "." + listBoxDirectories.SelectedItems[0].SubItems[1].Text);
							Log();
						}
						catch(Exception ex)
						{
							Log(ex.Message);
						}
					}
					else
					{
						try
						{
							conn.RemoveDir(listBoxDirectories.SelectedItems[0].Text.Substring(2, listBoxDirectories.SelectedItems[0].Text.Length - 4)); 
							Log();
						}
						catch(Exception ex)
						{
							Log(ex.Message);
						}
					}
					break;
			}
		}

		private void buttonConnect_Click(object sender, System.EventArgs e)
		{					
			conn.CloseConnection();
			try
			{
				conn.OpenConnection(textHostname.Text, textUser.Text, textPassword.Text);
				Log();
			}
			catch(Exception ex)
			{
				Log(ex.Message);
				return;
			}
			
			ArrayList directories = conn.ListDirEx();
			Log();
			
			listBoxDirectories.Items.Add("..");
			for( int i = 0; i < directories.Count; ++i )
			{
				String[] info = (String[])directories[i];
				if (info.Length > 2)
				{			
					String attrs = info[0];	
					String name = "";
					String type = "";
					if (attrs.Substring(0, 2) == "dr")
						name = "[ " + info[info.Length - 1] + " ]";
					else
					{
						int n = info[info.Length - 1].LastIndexOf(".");
						name = info[info.Length - 1].Substring(0, n+1);
						type = info[info.Length - 1].Substring(n+1);
					}
					ListViewItem it = new ListViewItem(name);
					it.SubItems.Add(type);
					it.SubItems.Add(attrs);
					listBoxDirectories.Items.Add(it);
				}
			}
			listBoxDirectories.Focus();
			listBoxDirectories.Select();
		}
		#endregion        

		#region Local File System
		private String[] GetLogicalDrives()
		{
			ArrayList indexes = new ArrayList();
			String[] drives = Directory.GetLogicalDrives();
			int i = 0;
			foreach(String drive in drives)
			{
				bool dirs = false;
				try
				{
					dirs = Directory.Exists(drive);
					if (dirs == true)
						indexes.Add(i);
				}
				catch(Exception e)
				{
				}
				i++;
			}
			String[] res = new String[indexes.Count];
			i = 0;
			foreach(int index in indexes)
			{
				res[i] = drives[index];
				i++;
			}

			return (i > 0) ? res : null;
		}

		private void InitDrivesCombo()
		{
			String[] drives = GetLogicalDrives();
			if (drives == null)
				return;
			cbDrives.Items.Clear();
            foreach(String drive in drives)
				cbDrives.Items.Add(drive);
			cbDrives.SelectedIndex = 0;
			cbDrives.Refresh();
		}

		private void FillLocalDir(String path)
		{
			CurrPath = path;
			lblLocalDir.Text = CurrPath;
			String[] dirs = Directory.GetDirectories(path);
			String[] files = Directory.GetFiles(path);
			LocalEntries.Clear();
			lwLocalDir.Items.Clear();
			lwLocalDir.Items.Add("..");
			foreach(String dir in dirs)
			{
				ListViewItem lwi = new ListViewItem();
				DirectoryInfo di = new DirectoryInfo(dir);
				lwi.Text = "[ " + di.Name + " ]";
				lwi.SubItems.Add("");
				lwi.SubItems.Add("");
				lwi.SubItems.Add(di.CreationTime.ToString());
				lwLocalDir.Items.Add(lwi);
				LocalEntry le = new LocalEntry();
					le.Path = di.FullName;
					le.Type = LocalEntryType.Dir;
				LocalEntries.Add(le);
			}
			foreach(String file in files)
			{
				ListViewItem lwi = new ListViewItem();
				FileInfo fi = new FileInfo(file);
				int dot = fi.Name.LastIndexOf(".");
				if (dot < 0)
					dot = fi.Name.Length;
				lwi.Text = fi.Name.Substring(0, dot);
				lwi.SubItems.Add((fi.Extension == "") ? fi.Extension : fi.Extension.Substring(1));
				lwi.SubItems.Add(fi.Length.ToString());
				lwi.SubItems.Add(fi.CreationTime.ToString());
				lwLocalDir.Items.Add(lwi);
				LocalEntry le = new LocalEntry();
				le.Path = fi.FullName;
				le.Type = LocalEntryType.File;
				LocalEntries.Add(le);
			}
		}

		private void lwLocalDir_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			switch (e.KeyCode)
			{
				case Keys.Enter:
					if (lwLocalDir.SelectedItems == null || lwLocalDir.SelectedItems.Count == 0)
						return;
					String sel = lwLocalDir.SelectedItems[0].Text;
					if (sel == "")
						return;

					if (lwLocalDir.SelectedIndices[0] == 0)
					{
						String oldPath = CurrPath;
						int slash = oldPath.LastIndexOf("\\");
						if (slash < 0)
							return;
						String newPath = oldPath.Substring(0, oldPath.LastIndexOf("\\"));
						FillLocalDir(newPath);
					}
					else if (((LocalEntry)LocalEntries[lwLocalDir.SelectedIndices[0]-1]).Type == LocalEntryType.Dir)
					{
						FillLocalDir(((LocalEntry)LocalEntries[lwLocalDir.SelectedIndices[0]-1]).Path);
					}
					lwLocalDir.Focus();
					lwLocalDir.Select();
					break;
				case Keys.F5:
					if (lwLocalDir.SelectedItems[0].Text.Substring(0, 2) != "[ ")
					{
						try
						{
							conn.UploadFile(CurrPath + "\\" + lwLocalDir.SelectedItems[0].Text + "." + lwLocalDir.SelectedItems[0].SubItems[1].Text);
							Log();
						}
						catch(Exception ex)
						{
							Log(ex.Message);
						}
					}
					break;
				case Keys.F7:
					FormCrDir fcd = new FormCrDir();
					DialogResult dr =  fcd.ShowDialog();
					if (dr == DialogResult.OK)
					{
						Directory.CreateDirectory(CurrPath + "\\" + fcd.DirName);
					}
					FillLocalDir(CurrPath);
					break;
				case Keys.Delete:
					if (lwLocalDir.SelectedItems[0].Text.Substring(0, 2) != "[ ")
						File.Delete(CurrPath + "\\" + lwLocalDir.SelectedItems[0].Text + "." + lwLocalDir.SelectedItems[0].SubItems[1].Text);
					else
						Directory.Delete(((LocalEntry)LocalEntries[lwLocalDir.SelectedIndices[0]-1]).Path);
					FillLocalDir(CurrPath);					
					break;
			}
		}
		private void cbDrives_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			FillLocalDir(cbDrives.SelectedItem.ToString());
		}
		#endregion

		#region Log
		private void Log()
		{
			foreach(String message in conn.MessageList)
			{
				listBoxLog.Items.Add(message);
			}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			if (conn.IsValidLicense)
				label8.Text = "License is valid";
			else
				label8.Text = "License is not valid";
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			conn.CloseConnection();
			listBoxDirectories.Items.Clear();
		}
	
		private void Log(String str)
		{
			listBoxLog.Items.Add(str);
		}
		#endregion
	}
}
